%% FEATURE READING
clear;
clc;
rng('default');
datascene=xlsread('adni','dr2') ;% READ EXCEL FILE FOR FEATURE OBTAINED VIA VBM ANALYSIS 
data=datascene(:,1:18);
grp=datascene(:,19:20);
x = data';
t = grp';
A=data;
B = (smoothdata(A,'gaussian',5));
C = (smoothdata(A,'gaussian',9));
D = (smoothdata(A,'gaussian',11));

%%TRAINING BR-NN
clear t1 x1;clear x2 t2;
    x=C'; % Selected for window=9!
    Q = size(x, 2);
    Q1 = floor(Q * 0.7);% FEATURE PARTIONING INTO TRAINING AND TESTING
    Q2 = Q - Q1;
    ind = randperm(Q);
    ind1 = ind(1:Q1);
    ind2 = ind(Q1 + (1:Q2));
    x1 = x(:, ind1);
    t1 = t(:, ind1);
    x2 = x(:, ind2);
    t2 = t(:, ind2);
trainFcn = 'trainbr'; 
% Then, ten neural networks are trained.
numNN = 10;
hiddenLayerSize = 20;
tt = cputime;
for j=1:hiddenLayerSize
    net = feedforwardnet(j,trainFcn);
    for i = 1:numNN
        fprintf('Training %d/%d\n', i, numNN)
        [nets{i,j},tr] = train(net, x1, t1);
        init(net);      
    end
end
e = cputime-tt

%%TESTING THE TRAINED NN need to change manually to test chosun(GARD)
perfs = zeros(i);
err=zeros(i,j);
y2Total = 0;
for j=1:hiddenLayerSize
    for i = 1:numNN
      neti = nets{i,j};
      y2= neti(x2);   
      tind = vec2ind(t2);
      yind = vec2ind(y2);
      percentErrors = sum(tind ~= yind)/numel(tind);
      err(i,j)=percentErrors;
      cp_bayesian(i,j)= classperf(tind,yind);
      acc1=cp_bayesian(i,j).CorrectRate
      sen1=cp_bayesian(i,j).Sensitivity
      spe1=cp_bayesian(i,j).Specificity
      acc(i,j)=acc1;
      sen(i,j)=sen1;
      spe(i,j)=spe1;
       init(net);
    end
end
acc=acc;
sen=sen;spe=spe;
meanacc=100*mean(acc);
stdAcc=100*std(acc);
meansen=100*mean(sen);
stdsen=100*std(sen);
meanspe=100*mean(spe);
stdspe=100*std(spe);
figure
xlim=1:20;
plot(xlim,meanacc);
ylim([0 100]);
hold on
plot(meansen);
hold on
plot(meanspe);
xlabel('No of Hidden layers');
ylabel('Avgerage Acc/Sens/Spec after 10 iterations ');
legend('Accuracy','Sensitivity','Specificity')
